=== include/CMakeLists.txt ===
add_subdirectory(triton)
