=== lib/CMakeLists.txt ===
# add_subdirectory(codegen)
add_subdirectory(Analysis)
add_subdirectory(Conversion)
add_subdirectory(Dialect)
add_subdirectory(Target)
