=== include/triton/CMakeLists.txt ===
add_subdirectory(Conversion)
add_subdirectory(Dialect)
