=== lib/Conversion/CMakeLists.txt ===
add_subdirectory(TritonToTritonGPU)
add_subdirectory(TritonGPUToLLVM)
