=== lib/Target/CMakeLists.txt ===
add_subdirectory(LLVMIR)
add_subdirectory(PTX)
