=== debian/changelog ===
triton (2.0.0.post1-3ubuntu1) mantic; urgency=medium

  * Fix FTBFS (LP: #2025279):
    - debian/control: use explicit Build-Depends: llvm-14-dev instead of
      llvm-dev
    - debian/rules: disable LTO

 -- Nick Rosbrook <nick.rosbrook@canonical.com>  Wed, 28 Jun 2023 13:26:16 -0400

triton (2.0.0.post1-3) unstable; urgency=medium

  * Uploading to unstable.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 11 Jun 2023 08:12:09 +0200

triton (2.0.0.post1-2) experimental; urgency=medium

  * Added missing dh-python, cmake and llvm-dev as build-depend.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 30 Apr 2023 11:09:22 +0200

triton (2.0.0.post1-1) experimental; urgency=low

  * Initial release (Closes: #1034144).
  * Uploading to experimental as this is not targeting Bookworm.

 -- Petter Reinholdtsen <pere@debian.org>  Mon, 17 Apr 2023 16:56:40 +0000
