=== debian/control ===
Source: triton
Section: python
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: M. Zhou <lumin@debian.org>, Petter Reinholdtsen <pere@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               libmlir-14-dev,
               llvm-14-dev,
               mlir-14-tools,
               python3-all-dev,
               python3-sphinx,
               python3-sphinx-gallery,
               python3-sphinx-multiversion
Standards-Version: 4.6.2.0
Testsuite: autopkgtest-pkg-pybuild
Homepage: https://github.com/openai/triton/
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/deeplearning-team/triton.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/triton

Package: python3-triton
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Description: language and compiler for custom Deep Learning operations
 For writing highly efficient custom Deep-Learning primitives. The aim
 of Triton is to provide an open-source environment to write fast code
 at higher productivity than CUDA, but also with higher flexibility
 than other existing domain specific languages.

#Package: python-triton-doc
#Section: doc
#Architecture: all
#Depends: ${misc:Depends}, ${sphinxdoc:Depends}
#Description: documentation for the triton Python library
# This package provides documentation for triton
