=== requirements.txt ===
# Core dependencies
torch>=2.0.0
triton>=2.0.0

# Development dependencies (optional, install with: pip install -r requirements-dev.txt)
# pytest>=7.0.0
# pytest-benchmark>=4.0.0
# torchvision>=0.15.0
# pillow>=9.0.0
# matplotlib>=3.5.0
