=== docs/requirements.txt ===
# Documentation requirements for MkDocs

mkdocs>=1.5.0
mkdocs-material>=9.4.0
mkdocstrings[python]>=0.24.0
pymdown-extensions>=10.0
